<template>
  <div>
    <TestBuilder v-model="testInner"/>
    <div class="d-flex">
      <v-btn @click="saveHandle" color="success">Сохранить</v-btn>
      <v-btn @click="cancelHandle" color="red" class="ml-3">Отменить</v-btn>
    </div>
  </div>
</template>
<script>
import { mapState, mapActions } from 'vuex';

export default {
  data() {
    return {
      testInner: {},
    }
  },
  watch: {
    editTest: {
      deep: true,
      async handler(v) {
        this.testInner = v;
      }
    }
  },
  computed: {
    ...mapState('teacher', ['editTest']),  
  },
  methods: {
    ...mapActions(['setMessageText']),
    ...mapActions('teacher', ['loadTest', 'updateTest']),
    async saveHandle() {
      const res = this.updateTest(this.testInner);

      if (!res.err) {
        this.setMessageText({
          text: 'Вы успешно отредактировали тест!',
          type: 'success',
        })
        setTimeout(() => this.$router.push('/test/list'));
      } else {
        this.setMessageText({
          text: res.err,
          type: 'error',
        })
      }
      
    },
    cancelHandle() {
      this.$router.push('/test/list');
    }
  },
  async created() {
    const { id } = this.$route.params;
    await this.loadTest({ _id: id });
  }
}
</script>